from random import *

def count_strictly_positives_0(a):
    n = len(a)
    c = 0
    for k in range(n):
        if a[k] > 0:
            c += 1
    return c

def count_strictly_positives_1(a):
    n = len(a)
    c = 0
    for k in range(n):
        c += 1 if a[k] > 0 else 0
    return c

def is_strictly_positive(x):
    return x > 0

def count_strictly_positives_2(a):
    return len(list(filter(is_strictly_positive, a)))

def count_strictly_positives_3(a):
    return len(list(filter(lambda x : x > 0, a)))

def count_strictly_positives_4(a):
    return len([x for x in a if x > 0])

def count_strictly_positives_5(a):
    return sum(1 for x in a if x > 0)

def count_strictly_positives_6(a):
    return sum(map(lambda x : 1 if x > 0 else 0, a))

def count_strictly_positives_7(a):
    if len(a) == 0:
        return 0
    else:
        b = a[1 : ]
        return (1 if a[0] > 0 else 0) + count_strictly_positives_6(b)

def all_results_count_strictly_positives(b):
    r = []
    r.append(count_strictly_positives_0(b))
    r.append(count_strictly_positives_1(b))
    r.append(count_strictly_positives_2(b))
    r.append(count_strictly_positives_3(b))
    r.append(count_strictly_positives_4(b))
    r.append(count_strictly_positives_5(b))
    r.append(count_strictly_positives_6(b))
    r.append(count_strictly_positives_7(b))
    return r

def are_equal_all_elements(a):
    return all(a[0] == a[j] for j in range(1, len(a)))

def test_count_strictly_positives(b):
    r = all_results_count_strictly_positives(b)
    return are_equal_all_elements(r)

def show_count_strictly_positives(b):
    print(b)
    r = all_results_count_strictly_positives(b)
    print('  Results obtained with various methods:')
    print('  ' + str(r) + '\n')

def show_small_examples():
    show_count_strictly_positives([4, -7, 0, 2, 5, 11, 365, -1])
    show_count_strictly_positives([3, 0, -5, 2, 17, -2, -2, 18])
    show_count_strictly_positives([])
    show_count_strictly_positives([-5, -2, -7])

def test_small_examples():
    b0 = test_count_strictly_positives([4, -7, 0, 2, 5, 11, 365, -1])
    b1 = test_count_strictly_positives([3, 0, -5, 2, 17, -2, -2, 18])
    b2 = test_count_strictly_positives([])
    b3 = test_count_strictly_positives([-5, -2, -7])
    return all([b0, b1, b2, b3])

def random_int_array(nmax, valmax):
    n = randint(0, nmax)
    return [randint(-valmax, valmax + 1) for k in range(n)]

def show_random_test_count_strictly_positives(nmax, valmax):
    q = random_int_array(nmax, valmax)
    show_count_strictly_positives(q)

def show_several_random_tests_count_strictly_positives(nmax, valmax, nsamples):
    for rep in range(nsamples):
        show_random_test_count_strictly_positives(nmax, valmax)

def random_test_count_strictly_positives(nmax, valmax):
    q = random_int_array(nmax, valmax)
    return test_count_strictly_positives(q)

def big_random_test_count_strictly_positives(nmax, valmax, nsamples):
    r = [random_test_count_strictly_positives(nmax, valmax) for k in range(nsamples)]
    return all(r)


#show_small_examples()

print('\nshow_several_random_tests_count_strictly_positives(10, 50, 4):\n')
show_several_random_tests_count_strictly_positives(10, 50, 4)

print('\nbig_random_test_count_strictly_positives(100, 1000, 100000):')
print(big_random_test_count_strictly_positives(100, 1000, 100000))

